# ShipStation API v2 Release Notes

A history of updates for ShipStation API v2!

## Version 2.0.0

### June 2026

- Carrier Document Upload endpoints for uploading customs documents to UPS and FedEx. See the [Carrier Document Upload guide](/upload-carrier-documents).
  - POST /v2/labels/{label_id}/documents - Register a document against a label
  - GET /v2/labels/{label_id}/documents - List documents for a label
  - DELETE /v2/labels/{label_id}/documents/{document_id} - Delete a label document
  - POST /v2/labels/{label_id}/documents/send - Send a label's documents to the carrier
  - GET /v2/documents/{document_id}/download - Download a document file
  - POST /v2/shipments/{shipment_id}/documents - Register a document against a shipment
  - GET /v2/shipments/{shipment_id}/documents - List documents for a shipment
  - DELETE /v2/shipments/{shipment_id}/documents/{document_id} - Delete a shipment document
  - GET /v2/shipments/{shipment_id}/labels - List shipments and their document statuses


### April 2026

- `/v2/mailing` endpoints with the following operations:
  - POST /v2/mailing/netstamps - Create NetStamps labels
  - POST /v2/mailing/mail_labels - Create mailing labels
  - POST /v2/mailing/envelopes - Create a single envelope label
- `/v2/shipments/user` endpoints with the following operations:
  - POST /v2/shipments/user - Assign a user to up to 500 shipments at once


### March 2026

- `/v2/purchase_orders` endpoint with the following operations:
  - GET /v2/purchase_orders
  - POST /v2/purchase_orders
  - GET /v2/purchase_orders/{purchase_order_id}
  - PUT /v2/purchase_orders/{purchase_order_id}
  - POST /v2/purchase_orders/{purchase_order_id}/shipping_details
  - POST /v2/purchase_orders/{purchase_order_id}/status
  - POST /v2/purchase_orders/{purchase_order_id}/receives
  - GET /v2/purchase_orders/{purchase_order_id}/documents/order_summary
  - GET /v2/purchase_orders/{purchase_order_id}/documents/received_summary
- `/v2/suppliers` endpoint with the following operations:
  - GET /v2/suppliers
  - POST /v2/suppliers
  - GET /v2/suppliers/{supplier_id}
  - PUT /v2/suppliers/{supplier_id}


### February 2026

- `/v2/totes` endpoint with the following operations:
  - GET /v2/totes - List all totes, optionally filtered by warehouse
  - POST /v2/totes - Create multiple totes in batch
  - GET /v2/totes/quantities - Get tote counts grouped by warehouse
  - GET /v2/totes/{tote_id} - Get a specific tote by ID
  - PUT /v2/totes/{tote_id} - Update a tote's name or barcode
  - DELETE /v2/totes/{tote_id} - Delete a tote


### August 2025

- `/v2/fulfillments` endpoint with the following operations:
  - GET /v2/fulfillments
  - POST /v2/fulfillments


### January 2025

- `/v2/inventory` endpoint with the following operations:
  - GET /v2/inventory
  - POST /v2/inventory
- `/v2/inventory_warehouses` endpoint with the following operations:
  - GET /v2/inventory_warehouses
  - POST /v2/inventory_warehouses
  - GET /v2/inventory_warehouses/{inventory_warehouse_id}
  - PUT /v2/inventory_warehouses/{inventory_warehouse_id}
  - DELETE /v2/inventory_warehouses/{inventory_warehouse_id}
- `/v2/inventory_locations` endpoint with the following operations:
  - GET /v2/inventory_locations
  - POST /v2/inventory_locations
  - GET /v2/inventory_locations{inventory_location_id}
  - PUT /v2/inventory_locations{inventory_location_id}
  - DELETE /v2/inventory_locations{inventory_location_id}


### October 31 2024

- `/v2/batches` endpoint with the following operations:
  - GET /v2/batches
  - POST /v2/batches
  - GET /v2/batches/external_batch_id//{external_batch_id}
  - DELETE /v2/batches/{batch_id}
  - GET /v2/batches/{batch_id}
  - PUT /v2/batches/{batch_id}
  - POST /v2/batches/{batch_id}/add
  - GET /v2/batches/{batch_id}/errors
- `/v2/carriers` endpoint with the following operations:
  - GET /v2/carriers
  - GET /v2/carriers/{carrier_id}
  - GET /v2/carriers/{carrier_id}/options
  - GET /v2/carriers/{carrier_id}/packages
  - GET /v2/carriers/{carrier_id}/services
- `/v2/downloads` endpoint with the following operation:
  - GET /v2/downloads/{dir}/{subdir}/{filename}
- `/v2/labels` endpoint with the following operations:
  - GET /v2/labels
  - POST /v2/labels
  - POST /v2/labels/rates/{rate_id}
  - POST /v2/labels/shipment/{shipment_id}
  - GET /v2/labels/{label_id}
  - POST /v2/labels/{label_id}/return
  - GET /v2/labels/{label_id}/track
  - PUT /v2/labels/{label_id}/void
- `/v2/manifests` endpoint with the following operations:
  - GET /v2/manifests
  - POST /v2/manifests
  - GET /v2/manifests/{manifest_id}
- `/v2/pickups` endpoint with the following operations:
  - GET /v2/pickups
  - POST /v2/pickups
  - GET /v2/pickups/{pickup_id}
  - DELETE /v2/pickups/{pickup_id}
- `/v2/packages` endpoint with the following operations:
  - GET /v2/packages
  - POST /v2/packages
  - GET /v2/packages/{package_id}
  - PUT /v2/packages/{package_id}
  - DELETE /v2/packages/{package_id}
- `/v2/rates` endpoint with the following operations:
  - GET /v2/rates
  - POST /v2/rates/estimate
  - GET /v2/rates/{rate_id}
- `/v2/shipments` endpoint with the following operations:
  - GET /v2/shipments
  - GET /v2/shipments/external_shipment_id/{external_shipment_id}
  - GET /v2/shipments/{shipment_id}
  - PUT /v2/shipments/{shipment_id}/cancel
  - GET /v2/shipments/{shipment_id}/rates
  - POST /v2/shipments/{shipment_id}/tags/{tag_name}
  - DELETE /v2/shipments/{shipment_id}/tags/{tag_name}
- `/v2/tags` endpoint with the following operations:
  - GET /v2/tags
  - POST /v2/tags/{tag_name}
- `/v2/tracking` endpoint with the following operation:
  - POST /v2/tracking/stop
- `/v2/warehouses` endpoint wiht the following operations:
  - GET /v2/warehouses
  - GET /v2/warehouses/{warehouse_id}
- `/v2/environment/webhooks` endpoint with the following operations:
  - GET /v2/environment/webhooks
  - POST /v2/environment/webhooks
  - GET /v2/environment/webhooks/{webhook_id}
  - PUT /v2/environment/webhooks/{webhook_id}
  - DELETE /v2/environment/webhooks/{webhook_id}